import logging as log
from .r_helper import RedisManager


async def ping():
    async with RedisManager() as redis_connect:
        if redis_connect:
            result = await redis_connect.client.ping()
            log.info("Ping - %s", result)
            return result


async def set_value(key, value):
    async with RedisManager() as redis_connect:
        if redis_connect:
            await redis_connect.client.set(key, value)
            log.info("Set %s = %s", key, value)


async def get_value(key):
    async with RedisManager() as redis_connect:
        if redis_connect:
            value = await redis_connect.client.get(key)
            log.info("Get %s = %s", key, value)
            return value


async def pop_value(key):
    async with RedisManager() as redis_connect:
        if redis_connect:
            value = await redis_connect.client.getdel(key)
            log.info("Get and delete %s = %s", key, value)
            return value
